<?DTD2HTML window>
<p>
Creates a window or form widget. You normally want to put a box or vbox in a window
though it takes all widgets. A dbobject should be used here also for a data
source if it has only one database source. The attribute visible defaults to
false, so if you want to make the window visible you must specify "true" here.
</p>
<p>
For more information on widget packaging and using boxes
you can see the GTK documenation or use Glade to get a feel for how to lay
out widgets.
</p>
<?DTD2HTML window*title>
<p>Sets the title for the window.</p>
<?DTD2HTML window*visible>
<p>If the widget is visible or not.</p>
<?DTD2HTML entry>
<p>
Entry is the equivilant of GtkEntry* in uigtk. It is a text input box. This makes
it a core component for data entry. 
</p>
<?DTD2HTML inputrestrict>
<p>
Inputrestrict can be used to restrict what can be typed into a entry
box like integer elements only or all capalised.
</p>
<?DTD2HTML function>
<p>
A function can be called in your own C programme or a library
you are linking to bondfrontend.  This is useful to add real
functionality to your programmes.  In your .conf file
you can get bond to link libraries at runtime which can contain
functions you might want to call on user actions (ie user clicks
on a button). 
</p>
<p>
Also when you build bond you can create your
own binary that calls the bond main api, and any function
in your source code can be called. When it is called it is passed
a BondObject* from what widget it was called from. Normally
this is the button. But it is also passed GList * of every argument
specified. These are void*'s (normally resolving to a gchar*).
</p>
<?DTD2HTML dbobject*name>
<p>
You should make the name the same as the widget the dbobject
occurres in to save confusion. Some calls use this name, while
some others use the widget name the dbobject occurres in.
</p>
<?DTD2HTML childwindow>
<p>
Sometimes you need to specify that a window is a child of a parent
window. Any childwindow's that appear in a window will be closed
when the parent form is closed. Also when any save or refresh
happens these child forms will also be saved or refreshed. 
Its a handy way to link forms that may not be as closely
related as the <loadby> forms are.
</p>
<?DTD2HTML lookup>
<p>
A lookup occurres in a dropdown box and is used to populate the data.
It will specify what fields are displayed in the dropdown box, what
record will be used to save back to the database. You can
have more than one field and use the attribute appendtext to 
add text to link between fields.
</p>
<?DTD2HTML trigger>
<p>
Triggers occur when you carry out an action on a widget. You usually place
them on a button or menu item. You can have more than one trigger assigned
to a function to catch multiple callbacks. The trigger could call a
customised function or call a bond api call. 
</p>
<p>
The event is what to catch on. This could default, change, entry, exit,
click, beforepaint, afterpaint, beforesave, aftersave, select, open, close,
add or delete. Not all of these have been implimented and clicked and
select are the two most commonly used ones.
</p>
<?DTD2HTML menubar>
<p>
Menubar is the standard menu along the top of the window. Use label to name
the menu item. Put a _ infront of any letter to make it a short cut key press.
</p>
<?DTD2HTML menu>
<p>
Contains lots of menu items. 
</p>
<?DTD2HTML inputrestrict>
<p>
Inputrestrict flags can be placed next to <field> tags to restrict the input
input in some way for the field.  For example it can be made to accept
only integer input or float input. Or make the first letter to capilised. 
</p>
