#ifndef PRINT_H
#define PRINT_H

int print_init (void);
int print_cleanup (void);

int print_has_previews (void);
int print_show_previews (void);

int print_start_file (char *filename, char *papername);
int print_start_preview (char *papername);
int print_start_printer (char *papername);
void print_stop (int *printer);

void print_newpage (int *printer);
void print_showpage (int *printer);

void print_newpath (int *printer);
void print_moveto (int *printer, int *x, int *y);
void print_lineto (int *printer, int *x, int *y);
void print_box (int *printer, int *x, int *y, int *width, int *height, int *fill);
void print_stroke (int *printer);
void print_setlinewidth (int *printer, double *width);

void print_setcolour (int *printer, double *red, double *green, double *blue);
int print_getfont (char *name, double *size);
void print_setfont (int *printer, int *font);
int print_lineheight (int *font);
int print_linewidth (int *font, char *text);
int print_showat (int *printer, int *font, int *x, int *y, char *text);
int print_show_centered (int *printer, int *font, int *x0p, int *x1p, int *y, char *text);
int print_show (int *printer, int *font, char *text);
int print_show_paragraph (int *printer, int *fontp, int *para_width,
			   int *xp, int *yp, char *text);
void print_image (int *printer, int *x, int *y, char *filename);
void print_image_scaled (int *printer, int *x, int *y, double *scale, 
			 char *filename);

int print_paper_width (void);
int print_paper_height (void);

extern int print_current_page;

#endif /* PRINT_H */
