variable printer, font1, font2, font1b, width, height;
   
variable fonts, i;
fonts = print->fonts ();
for (i = 0; i < length(fonts); i++) printf ("font: %d: %s\n", i, fonts[i]);

width = print->paper_width ("a4");
height = print->paper_height ("a4");
font1b = print->getfont ("Helvetica Bold", 8);
font1 = print->getfont ("Helvetica", 8);
font2 = print->getfont ("Times Bold", 36);

%printer = print->start_file ("./output.ps", "a4");
%printer = print->start_printer ("a4");
printer = print->start_preview ("a4");

print->newpage (printer);

%print->showat(printer, font1, 100, 600, gen->query_string ("Hey, what is your name?", "Git Boy"));
%print->showat (printer, font2, 100, 500, gen->query_date ("Hey, what is the date?", gen->today ()));
%print->showat (printer, font2, 100, 400, string (gen->query_double ("waah", 10, -5, 100)));

print->newpath (printer);
print->moveto (printer, 50, 50);
print->lineto (printer, 100, 50);
print->stroke (printer);

print->setlinewidth (printer, 10);
print->moveto (printer, 50, 70);
print->lineto (printer, 100, 70);
print->stroke (printer);


print->setcolour (printer, 0.7, 0.7, 0.7);
print->box (printer, 99, 100 + print->font_height (font1), print->line_width (font1, "Waaah Andru!") + 2, print->font_height (font1) + 2, 1);
print->setcolour (printer, 0, 0, 0);
print->showat (printer, font1, 100, 100, "Waaah Andru!");

print->moveto (printer, 200, 100);
print->show (printer, font2, "This is big text... WAAAH");

variable str;
str = "Date is: " + date;
print->showat (printer, font1, 100, 200, str);

print->showpage (printer);

print->newpage (printer);
print->moveto (printer, 10, height - 100);
print->show (printer, font2, "page 2");
print->show_paragraph (printer, font1, 100, 400, height - 120, "This should be a narrow paragraph\nThis is going to start a new line now\nAnd again");
variable size;
size = print->show_paragraph (printer, font1, 200, 10, height - 120, "This is some text, that goes on for bloody ages. I don't know how long. But it certainly does keep going... WOOOHOOOAnd then I added some more text, which I think it was");

print->moveto (printer, 10, height - 120 - size - print->font_height (font1));
print->show (printer, font1, "Should be below the huge paragraph");

print->box (printer, 9, height - 119 + print->font_height (font1) , 202, size + 2, 0);

print->showpage (printer);

print->newpage (printer);

% Database test code
variable obj, email, num, i, count;

%obj = bond->createobject ("person");
%bond->getobjectbyfield (obj, "lastname", "hill");
%email = bond->getfieldstr(obj, "email");
%printf ("Email: %s\n", email);
%bond->freeobject(obj);

print->moveto (printer, 40, height - 55);
print->show (printer, font2, "Email Addresses");

obj = bond->createobject ("person");
bond->loadallobjects (obj);
num = bond->num (obj);

count = 0;
for (i = 0; i < num; i++)
   {
   bond->moverecord (obj, i);
   email = bond->getfieldstr (obj, "email");
   if (email != "")
      {
      print->moveto (printer, 40, height - count * (print->font_height (font1) + 5) - 65);
      print->show (printer, font1, "Email: " + email);
      count++;
      }
   }
bond->freeobject (obj);

print->moveto (printer, 10, height / 2);
print->setcolour (printer, 1, 0, 0);
print->show (printer, font1, "This is where the image should be! (RED)");
print->moveto (printer, 10, height / 2 - 30);
print->setcolour (printer, 0, 0, 1);
print->show (printer, font2, "This is blue!");

print->image_scaled (printer, 10, height / 2 - 100, 0.5, "logo.png");

print->setcolour (printer, 0, 0, 0);
print->showat (printer, font1, 100, 600, "This is a showat text");

print->showpage (printer);

print->newpage (printer);

variable l_fname, l_lname, l_email, l_width, l_height, l_obj, l_pos, 
   l_num, l_label1, l_label2, l_label3;

l_obj = bond->sql ("Select *, oid from person");

define display_heading ()
   {
   variable str;
   
   print->setcolour (printer, 1.0, 0.0, 1.0);
   print->showat (printer, font2, 40, height - 60, "Heading");
   str = "Page: " + string (print->current_page);
   print->showat (printer, font2, 300, height - 60, str);
   }

define display_footer ()
   {
   print->showat (printer, font2, 40, 10, "Waahh.. footer");
   }


l_label1 = layout->begin ("firstnamelabel", "string", "data=First Name: ", "colour=0,0,0");
l_fname = layout->add (l_label1, "firstname", "string", "rightof", "minwidth=100", "font=Helvetica Bold");
l_label2 = layout->add (l_fname, "lastnamelabel", "string", "rightof", "data=Last Name: ", "font=Helvetica");
l_lname = layout->add (l_label2, "lastname", "string", "rightof", "font=Helvetica Bold", "colour=0,0,0.4");
l_label3 = layout->add (l_label1, "emaillabel", "string", "below", "data=Email: ", "font=Helvetica", "colour=0,0,0");
l_email = layout->add (l_label3, "email", "string", "rightof");

layout->fulldisplay (printer, % Printer
		     l_obj, % Database object
		     l_fname, % Layout
		     100, % X
		     height - 200, % Y
		     50, % Bottom
		     "display_heading",
		     "display_footer");


print->showpage (printer);
print->stop (printer);
