/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef livepath_h
#define livepath_h

#include "bond.h"
#include "bondmain.h"
#include "fieldpath.h"

typedef struct _LivePath LivePath;

struct _LivePath
	{
	/* Constant data */
	FieldPath *fieldpath;
	LivePath *next;
	LivePath *prev;
	LivePath *parent;
	/* Variable data */
	gchar *linkvalue;
	BondObject *bobj;
	BondObject *bobjlink;
	gboolean present;
	};

LivePath * livepath_create(Bond * bond, GList *fieldpathlist);
gint livepath_evaulate(Bond * bond, LivePath * livepath, BondObject * from);
gint livepath_test(gint testnum, Bond *bond);

/**
 * Given a fieldpath, this function will attempt to see which if any of the 
 * arguments are visible at the moment and if there values should be used 
 * instead.
 * 
 * The fieldpath bit only works on the database orinated end.
 */

#endif
