/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <stdlib.h>

/* test tmp code */
#include "db.h"
#include "dbclient.h"

#include "ui.h"

#include "superglue.h"
#include "roof.h"
#include "stickypaper.h"
#include "postit.h"
#include "debug.h"

static UiWidget *getcomboboxparent(UiWidget * widget);

void
on_data_changed(UiWidget * widget, gpointer user_data)
{
	SignalInfo *sig = NULL;
	UiWidget *otherwidget;
	extern gchar frezzechanges;
#if 0
	printf("on_data_changed() by %s", ui_getname(widget));
	if (frezzechanges == 0)	{
			
		if (user_data != NULL)
			sig = (SignalInfo *) user_data;
		
		if (sig == NULL)
			return ;
		
		/* Francis: The following bizzare code is owing to the
		 evil GtkCombo's annoying design */
		if (sig->widgetname != NULL) {
			otherwidget = ui_getwidget(sig->widgetname);
			if (ui_gettype(otherwidget) == UiDropDown) {
				//debugnote("Dropdown changed");
				debugmsg("Dropdown widget changed: %s",
					 sig->widgetname);

				/* Francis: Propagate dropdown chain-reaction
				 if the dropdown belong to dropdown group */
				postit_setdropdownchanged(otherwidget, sig);

				
				postit_setwidgetchanged(otherwidget, sig);

				return ;
			}
		}
		postit_setwidgetchanged(widget, sig);
	}
	/* else debugmsg("hello i just was here with a record
	   changed. I didn't set cause of freeze\n"); */
#endif
}

/* so dont do too much work */
void
on_dropdown_exit(UiWidget * widget, UiEvent * Event, gpointer user_data)
	{
	extern gchar frezzechanges;
	UiWidget *otherwidget;
	AliasDataSource *alias;
	SignalInfo *sig = NULL;

	debugmsg ("on_dropdown_exit() is invoked");
	if (frezzechanges == 0)
		{
		sig = (SignalInfo *) user_data;
		otherwidget = sig->widget;
		if (otherwidget != NULL)
			{
			if (ui_gettype(otherwidget) == UiDropDown)
				{
#if 0
				alias = sig->alias;
#endif
				/* alias = postit_getaliasbywidget(otherwidget); */
				if (alias == NULL)
					{
					warningmsg("I was unable to find an alias from widget %s", ui_getname(otherwidget));
					return ;
					}
				/* If the widget hasnt changed, well dont do anything dummy */
				if (alias->changed == 0)
					return ;
				debugmsg("Exiting widget is %s, this is a dropdown box", alias->widgetlongname);
				postit_setdropdownchanged(otherwidget, sig);
				return ;
				}
			else
				warningmsg("This isn't a combo box, %s", ui_getname(widget));
			}
		else
			warningmsg("Unable to find combo box assoicated with %s", ui_getname(widget));
		}
	}

void
on_toggle_changed(UiWidget * toggle_button, gpointer user_data)
	{
	on_data_changed(toggle_button, user_data);
	}

void
on_row_selected(UiWidget * clist, gint row, gint column, UiEvent * event, gpointer user_data)
	{
	extern gchar frezzechanges;
	gchar *formname;
	DataRoof *roof;

	debugmsg("on_row_selected() by %s", ui_getname(clist));

	if (frezzechanges != 0)
		return ;

	roof = dataroof_immedidateparent(ui_getname(clist), 1);
	if (roof == NULL)
		{
		errormsg("No parent widget was found for %s", ui_getname(clist));
		return ;
		}
	formname = roof->widgetlongname;
	debugmsg("Row selected on %s", formname);
	if (formname != NULL)
		bond_formshowrecord(formname, row);
	}

void
on_key_press(UiWidget * widgetp, UiEvent * event, gpointer user_data)
	{
	SignalInfo *sig;
	int stopit = 0;
	int printstuff = 0;
	gboolean stuff;
	UiWidget *widget;
	UiWidgetType widgettype;

	sig = (SignalInfo *) user_data;
	widget = sig->widget;
	g_assert(widget);

	if (userentry_restrictentry(widgetp, event, user_data) == 1)
		return ;
	/* debugmsg("Name %s", widgetname); */

	ui_event_handlekeyevent(event, &stopit);

	if (stopit == 1)
		{
		/* widgetname = (gchar *) user_data; */
		/* gtk_widget_grab_focus(next_widget); */
		/* next_widget = (UiWidget *) ui_getwidget(widgetname); */

		ui_signalemitstopbyname(widget, "key-press-event");
		widgettype = ui_gettype(widget);

		/* nextwidget = getcomboboxparent(widget); */
/* THIS CODE HAS BEEN DISABLED, to give control back to wm. */
#if 0
		if (widgettype == UiDropDown)
			{
			ui_event_setvalue(event, UI_KEY, UI_KP_RIGHT);
			ui_signalemitbyname_arg_pUiEvent_pgboolean(widget, "key-press-event", event, &stuff);
			}
		else
			{
			ui_event_setvalue(event, UI_KEY, UI_KP_DOWN);
			ui_signalemitbyname_arg_pUiEvent_pgboolean(widget, "key-press-event", event, &stuff);
			}
#endif
		}

	if (printstuff == 1)
		{
		/* debugmsg("%s", (gchar *) event->window); */
		}

	}

void
on_key_press_dropdown(UiWidget * widgetp, UiEvent * event, gpointer user_data)
	{
/*	int stopit = 0;
	SignalInfo *sig;
	UiWidget *widget;

	sig = (SignalInfo *) user_data;
	widget = ui_getwidget(sig->widgetname);

	ui_event_handlekeyevent(event, &stopit);

	if (stopit == 1)
		{
		// gtk_signal_emit_stop_by_name(GTK_OBJECT(widget), "key-press-event");

		}
*/
	}

void
on_form_delete(UiWidget * form, gpointer user_data)
	{
	bond_formsave(ui_getparentformname(form));
	bond_formclose(ui_getparentformname(form));

	ui_hidewidget(form);
	}

void
on_test(UiWidget * widget, gpointer user_data)
	{
	ui_issignalattached(widget, "clicked");

	ui_showwidget(widget);

	/* DataRoof *roof = dataroof_getbyname("membership"); printf("called from %s\n",getwindow(widget)); if(roof==NULL)
	   return; displayalias(roof->fields); */
	}

static UiWidget *
getcomboboxparent(UiWidget * widget)
	{
	gint i;
	gchar *widgetname;
	UiWidget *retwidget = NULL;

	widgetname = mem_strdup(ui_getname(widget));

	for (i = strlen(widgetname) - 1; i >= 0; i--)
		{
		if (widgetname[i] == '.')
			{
			widgetname[i] = 0;
			retwidget = ui_getwidget(widgetname);
			break;
			}
		widgetname[i] = 0;
		// debugmsg("name %s", widgetname);
		}
	mem_free(widgetname);
	return retwidget;
	}

void
uicallback_focusoutevent(UiWidget * widget, UiEvent * Event, gpointer user_data)
	{
	userentry_checkonfocusout(widget, (SignalInfo *) user_data);
	imethod_widgetsignal(widget, (SignalInfo *) user_data);
	}


/**
 * on_dropdown_selection_done:
 *
 * This function is written by Francis.
 * This use a bit dangerous, or unproven to be safe yet, emulation
 * But it could be used to construct very robust of the other part of system
 * namely, the signal (or event) flow control.
 *
 * In a nutshell, Francis had had a problem how to detect a selection event
 * of combobox. One can connect signal "changed" to the combo->entry
 * but Francis wanted to detect a case when user selected the item that
 * was selected previously as well. In terms of data entry change, 
 * nothing has changed.
 *
 * So Francis has found that combobox has popwin member and detect when
 * its signal "hide" is called. However, one problem is it will still be
 * called as selected when items are empty. This problem can be fixed
 * by checking the number of items additionally.
 */
/*
void
on_dropdown_selection_done(GtkWidget *w, gpointer user_data)
{
	debugnote("Dropdown was selected, hehe");
}
*/
