#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <libxml/parser.h>

#include "xml_display.h"
#include "bc.h"
#include "uiradiobutton.h"
#include "parse.h"

GtkWidget *
uigtk_radio_button_create(xmlNode * parentnode, GtkWidget * parentwidget)
{
     GtkWidget *widget = NULL;
     GtkWidget *group = NULL;
     gchar *content = NULL;
     GList *children = NULL;

     children = gtk_container_get_children(GTK_CONTAINER(parentwidget));
     /* assume that the first child of a container widget is the group
     that these radio buttons belong to */
     if (children)
	  group = children->data;

     content = xmlGetProp(parentnode, "group");
     if (content)
	  widget = gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(group));
     else
	  widget = gtk_radio_button_new(NULL);

     content = xmlGetProp(parentnode, "label");
     if (content) 
	     gtk_button_set_label(GTK_BUTTON(widget), content);

     content = xmlGetProp(parentnode, "use_underline");
     if (content && IsTrue(content))
	  gtk_button_set_use_underline(GTK_BUTTON(widget), TRUE);
     else
	  gtk_button_set_use_underline(GTK_BUTTON(widget), FALSE);

     content = xmlGetProp(parentnode, "active");
     if (content && IsTrue(content))
	     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
     else
	     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
     
     content = xmlGetProp(parentnode, "relief");
     if (content) {
	     if(IsEqual(content, "none"))
		     gtk_button_set_relief(GTK_BUTTON(widget), GTK_RELIEF_NONE);
	     else if (IsEqual(content, "half"))
		     gtk_button_set_relief(GTK_BUTTON(widget), GTK_RELIEF_HALF);
     }
     else
	     gtk_button_set_relief(GTK_BUTTON(widget), GTK_RELIEF_NORMAL);
     

     gtk_widget_show(widget);

     debugmsg("Returning radio button");
     return widget;
}
