#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <libxml/parser.h>

#include "parse.h"
#include "bc.h"
#include "uidropdown.h"
#include "uilist.h"
#include "uibox.h"
#include "uimessage.h"
#include "uihtmlsession.h"

int
main (int argc, char *argv[])
{
  UiXML *bondxml;
  gchar *tmpstr;
  
  bc_init(argc,argv);
  gtk_init (&argc, &argv);
  if(argc != 2)
	{
	  fprintf(stderr, "No input file\n");
	  return 1;
	}
  bondxml = uixml_init(argv[1]);

  if (bondxml == NULL)
	return -1;

  uihtmlsession_set(bondxml);

  debugmsg("testsession\nsessionid:       \t %s\ncreated at\t[%s]\n",
		 bondxml->sessionid, 
		 (char *)ctime((time_t *)&bondxml->creation_time));
  tmpstr = mem_strdup_printf("http://www.google.com/?q=ratrace&sid=%s&fun=yes", bondxml->sessionid);
  debugmsg("parsing %s ",tmpstr);
  tmpstr = uihtmlsession_get(tmpstr);
  debugmsg("got session %s", tmpstr);
  
  message("parsing parent");
  uihtml_parse(bondxml);
  message("parse complete");
  /*gtk_main();*/ 

  debugmsg("[%s]", __PRETTY_FUNCTION__);

  bc_cleanup();
  return 0;
}

