#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <libxml/parser.h>

#include "xml_display.h"
#include "bc.h"
#include "uiframe.h"
#include "parse.h"

UiHtml *
uihtml_frame_create(UiXML * uixml, xmlNode * widgetnode, UiHtml * parentwidget,
		 gboolean * visible)
{
	UiHtml *frame;
	gchar *content = NULL;
	gfloat xalign = 0;
	gfloat yalign = 0;


	gtk_widget_show(frame);
	
	content = xmlGetProp(widgetnode, "label");
	if (content) 	
		frame = gtk_frame_new(content);
	else
		frame = gtk_frame_new(NULL);
	
	content = xmlGetProp(widgetnode, "xalign");
	if (content) xalign = atof(content);

	content = xmlGetProp(widgetnode, "yalign");
	if (content) yalign = atof(content);

	gtk_frame_set_label_align(GTK_FRAME(frame), xalign, yalign);
	debuglog(50, "Creating a frame");
	return frame;
}
