#ifndef uihtml_h
#define uihtml_h

#include <libxml/parser.h>
#include <glib.h>

#include "../src/uicommonplugin.h"

typedef struct _UiHtml UiHtml;
typedef struct _UiHtml UiWidget;

struct _UiHtml
{
  xmlNode *node;
  
  GList *children;
  UiHtml *parent;
  
  gint widgettype;
  gboolean visible;	/* If its visible or not */	
  gboolean editable;	/* If widget is editable or not. */
	
  gchar *openinghtml;
  gchar *closinghtml;
  gchar *value;
  
  /* Widget specific information */
  gchar *title;
  /* Box stuff */
  gint vboxtrue;
  gint order; /* order of this widget */
  gint vhordercounter; /* a counter for generating child widget orders */
  gint xsize; /* dimensons of the box */
  gint ysize;
};

/* The rest of it */
UiXML *uihtml_init(gchar * xmlfile, gint argc, gchar * argv[]);
void uihtml_parse(UiXML*);
void uihtml_main(UiXML*);
void uihtml_mainquit(UiXML*);
void uihtml_cleanup(UiXML*);
void *uihtml_getuixml(UiXML*);

gint plugin_init(Plugin * plugin);
void plugin_cleanup(Plugin * plugin);
gint plugin_addfunction(Plugin * plugin, gchar * funcname, void *(*funcptr) ());
UiHtml *uihtml_create(xmlNode *node);
gint uihtml_output(int indent, UiXML * uixml, UiHtml *uihtml);

#endif /* uihtml_h */
