#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glob.h>
#include <dlfcn.h>

#include <time.h>
#include <openssl/evp.h>

#include <glib.h>

#include "uihtml.h"
#include "bc.h"

#include "uihtmlsession.h"

/** uisession_set
 * sets session and creation time for uixml that is passed
 */
int
uihtmlsession_set(UiXML *bondxml)
{
  gchar *randstr;
  GRand *generator;
  EVP_MD_CTX mdctx;
  const EVP_MD *md;
  unsigned char md_value[EVP_MAX_MD_SIZE];
  int md_len, i;
  
  generator = g_rand_new();

  bondxml->creation_time  = time(NULL);

  randstr = mem_strdup_printf("%d", g_rand_int(generator));

  OpenSSL_add_all_digests();
  md = EVP_sha();

  EVP_MD_CTX_init(&mdctx);
  EVP_DigestInit_ex(&mdctx, md, NULL);
  EVP_DigestUpdate(&mdctx, randstr, strlen(randstr));
  EVP_DigestFinal_ex(&mdctx, md_value, &md_len);
  EVP_MD_CTX_cleanup(&mdctx);
  
  bondxml->sessionid = mem_strdup("");
  
  for(i = 0; i < md_len; i++)
	bondxml->sessionid = mem_strdup_printf("%s%02x", bondxml->sessionid, md_value[i]);
  
  return 0;
}

/** parses URLstring and returns session id string */
gchar *
uihtmlsession_get(gchar *URLstring)
{
  gchar *session = NULL;
  gchar *chop = NULL;
  
  session = mem_strdup(URLstring);
  session = strstr(session, "sid=")+4;
  
  chop = strchr(session, '&');
  if(chop)
	*chop='\0';
  
  return session;
}
