#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <libxml/parser.h>

#include "xml_display.h"
#include "bc.h"
#include "uispinbutton.h"
#include "parse.h"

/**
 * ui_button_create:
 * @parentnode: an xml node in the bond xml file
 * @parentwidget: parent widget of this node
 *
 * Creates a button based on the properties specified in the Xml node.
 *
 * Attributes:
 * digits
 * numeric
 * snap-to-ticks
 * step
 * page
 * defaultvalue
 * wrap
 * min
 * max
 * 
 * Returns: pointer to widget created
 */
UiHtml *
uihtml_spinbutton_create(UiXML * uixml, xmlNode * widgetnode, UiHtml * parentwidget, 
						gboolean * visible)
{
	gdouble value;
	guint digits = 0;
	gboolean flag = FALSE;
	gboolean range = FALSE;
	gchar *content = NULL;
	UiHtml *widget;
	guint step = 1;
	guint page = step * 10;
	gdouble min = 0;
	gdouble max = 100;

	content = xmlGetProp(widgetnode, "name");
	if (content)
		debuglog(50, "Creating spin box %s", content);
/*	else
		debuglog(50, "Creating spin box %s", parentwidget->name);
	*/
	

	content = xmlGetProp(widgetnode, "digits");
	if (content) {
		digits = atoi(content);

	}
	content = xmlGetProp(widgetnode, "numeric");
	if (content && IsTrue(content))
	  ;
	else
	  ;

	content = xmlGetProp(widgetnode, "snap-to-ticks");
	if (content && IsTrue(content))
	  ;
	else
	  ;
     
	content = xmlGetProp(widgetnode, "step");
	if (content) {
		step = atoi(content);
		flag = TRUE;
	}
  
	content = xmlGetProp(widgetnode, "page");
	if (content) {
		page = atoi(content);
		flag = TRUE;
	}
  
	content = xmlGetProp(widgetnode, "defaultvalue");
	if (content) {
		value = atoi(content);
		;
	}

	content = xmlGetProp(widgetnode, "wrap");
	if (content && IsTrue(content))
	  ;
	else
	  ;

	content = xmlGetProp(widgetnode, "min");
	if (content) {
		min = atoi(content);
		range = TRUE;
	}

	content = xmlGetProp(widgetnode, "max");
	if (content) {
		max = atoi(content);
		range = TRUE;
	}
     
	if (range) {
	  ;
	  range = FALSE;
	}
	if (flag) {
	  ;
	  flag = FALSE;
	}
	
	widget = NULL;
	return widget;
}
